import 'package:flutter/material.dart';

class Tile {
  Image image;
  Alignment alignment;


  Tile({required this.image, required this.alignment});

  Widget croppedImageTile(double widthFactor) {

    return FittedBox(
      fit: BoxFit.fill,
      child: ClipRect(
        child: Container(
          child: Align(
            alignment: this.alignment,
            widthFactor: widthFactor,
            heightFactor: widthFactor,
            child: image,
          ),
        ),
      ),
    );
  }
}

class Exo5 extends StatefulWidget {
  const Exo5({super.key});

  @override
  State<Exo5> createState() => _Exo5();
}

class _Exo5 extends State<Exo5> {
  final image = Image.network('https://picsum.photos/512');
  double? size = 300;
  int colNb = 3;

  @override
  Widget build(BuildContext context) {
    int i = 0;
    int j = 0;

    return Scaffold(
      appBar: AppBar(
        title: const Text('Display a Tile as a Cropped Image'),
        centerTitle: true,
      ), 
      body: Column(children: [
        Container(
          margin: const EdgeInsets.all(10.0),
          child: SizedBox(
            height: MediaQuery.of(context).size.height * 0.7,
            width: MediaQuery.of(context).size.height * 0.7,
            child: GridView.builder(
              gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                crossAxisCount: colNb,
              ),
              itemCount: colNb * colNb,
              itemBuilder: (BuildContext context, int index) {
                Tile tile;

                tile = Tile(image: image, alignment: 
                  Alignment(-1 + 2 * j.toDouble() / (colNb.toDouble() - 1),
                            -1 + 2 * i.toDouble() / (colNb.toDouble() - 1))
                );

                int ii = i;
                int jj = j;
                
                j++;
                if(j == colNb){
                  i++;
                  j = 0;
                }

                return Flexible(child: Container(
                  margin: EdgeInsets.all(10.0 / colNb),
                  child: InkWell(
                    child: tile.croppedImageTile(1 / colNb),
                    onTap: () {
                      print("tapped on " + ii.toString() + " " + jj.toString());
                    }
                  )
                ));
              }
            )
          )
        ),
        Slider(
          value: colNb.toDouble(),
          min: 2,
          max: 6,
          onChanged: (double value) {
            setState(() {
              colNb = value.toInt();
            });
          }
        ),
      ]),
    );
  }
}
